#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_Synthesis.h"
#include "FileEncrypt.h"
std::auto_ptr<M_Synthesis> M_Synthesis::msSingleton(nullptr);

int M_Synthesis::GetCount()
{
	return (int)mMapData.size();
}

const M_SynthesisData* M_Synthesis::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_SynthesisData>& M_Synthesis::GetMapData()
{
	return mMapData;
}

void M_Synthesis::Reload()
{
	mMapData.clear();
	Load();
}

void M_Synthesis::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_SynthesisData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mneedItem = element->IntAttribute("needItem");
		data.mneedCount = element->IntAttribute("needCount");
		data.mItemName = element->Attribute("ItemName");
		data.mitemId = element->IntAttribute("itemId");
		data.mitemCount = element->IntAttribute("itemCount");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void M_Synthesis::Load()
{
	Load("../Config/M_Synthesis.xml");
}

M_Synthesis* M_Synthesis::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_Synthesis());
	}
	return msSingleton.get();
}
